/*-------------------------------------------------------------*\
 |   MIN.C   A Minimun Windows Program that displays a windos. |
 |   The window can be moved, sized, minimized and             |
 |   maximized                                                 |
\*-------------------------------------------------------------*/

#include <Windows.H>                 
#include <commdlg.h>

/*-------------------------------------------------------------*\
 |                     Functions Prototypes                    |
\*-------------------------------------------------------------*/
int janela = FALSE;

char szTeste [60] = "";

long FAR  PASCAL MarkerWndProc (HWND, WORD, WORD, LONG);
long FAR  PASCAL SecondWndProc (HWND, WORD, WORD, LONG);
UINT CALLBACK FileOpenHookProc (HWND, UINT, WPARAM, LPARAM);
UINT CALLBACK SegundaJanelaDialogo (HWND, UINT, WPARAM, LPARAM);
VOID NEAR PASCAL MarkerDrawMarker (HDC, int, int);

/*-------------------------------------------------------------*\
 |                  Main Function: WinMain.                    |
\*-------------------------------------------------------------*/
  HMENU hmenu;

HANDLE hgeral;
HWND hwndDlg = NULL;
int PASCAL WinMain (HANDLE hInstance,
		    HANDLE hPrevInstance,
		    LPSTR  lpszCmdLine,
		    int    cmdShow)

{
  HWND      hwnd;
  MSG       msg;
  WNDCLASS  wndclass;

  hgeral = hInstance;
  if (hPrevInstance)  {
    MessageBeep (MB_ICONQUESTION);
    exit (0);
  }

    wndclass.lpszClassName  =  "MARKER:MAIN";
    wndclass.hInstance      =  hInstance;
    wndclass.lpfnWndProc    =  MarkerWndProc;
    wndclass.hCursor        =  LoadCursor (hInstance, "hand");
    wndclass.hIcon          =  LoadIcon (hInstance, "snapshot");
    wndclass.lpszMenuName   =  "MENU_1";
    wndclass.hbrBackground  =  COLOR_WINDOW + 1;
    wndclass.style          =  CS_HREDRAW | CS_VREDRAW;
    wndclass.cbClsExtra     =  0;
    wndclass.cbWndExtra     =  0;

    RegisterClass (&wndclass);   
  

  hwnd  =  CreateWindow ("MARKER:MAIN",               /* Class name.    */
			 "Markers",                   /* Title.         */
			 WS_OVERLAPPEDWINDOW,         /* Style bits.    */
			 50,                          /* x - default.   */
			 50,                          /* y - default.   */
			 500,                         /* cx - default.  */
			 250,                         /* cy - default.  */
			 NULL,                        /* No parent.     */
			 NULL,                        /* Class menu.    */
			 hInstance,                   /* Creator.       */
			 NULL                         /* Params.        */
			);

/*  hmenu = LoadMenu (hInstance, "MENU_1");
      SetMenu (hwnd, hmenu);
  */
  ShowWindow (hwnd, cmdShow);
     
   
  while (GetMessage (&msg, 0, 0, 0)) {
    if (!IsDialogMessage (hwndDlg, &msg)) {
      TranslateMessage (&msg);
      TranslateAccelerator (hwnd, NULL, &msg);
      DispatchMessage (&msg);
    }
  }
 
  return 0;
 
}

/*-------------------------------------------------------------*\
 |            Window Procedure:  MinWndProc.                   |
\*-------------------------------------------------------------*/

long FAR PASCAL MarkerWndProc (HWND   hwnd,
		               WORD   msg,
			       WORD   wParam,
			       LONG   lParam)
{

  static POINT pt [32];
  static int   cpt = 0;
  HWND hwnd2;
  WNDCLASS wnd2class;

  DLGPROC dlgprc;

  switch (msg) {
    case WM_CLOSE: 
      if (MessageBox (hwnd, "Tem certeza?", "Sair Marker",
		      MB_ICONQUESTION | MB_OKCANCEL) == IDOK) {
	WinHelp (hwnd, "marker.hlp", HELP_QUIT, NULL);
	DestroyWindow (hwnd);
      }
      return 0L;

    case WM_DESTROY: {
	PostQuitMessage (0);
      break;
    }
    case WM_DRAWITEM: {
    }
                    
    case WM_COMMAND: {
      if (wParam == 101) {
	MessageBeep (MB_ICONQUESTION);
	if (MessageBox(hwnd, "Tem certeza?", "Sair do Programa",
        	   MB_ICONQUESTION | MB_OKCANCEL) == IDOK) {
  	   WinHelp (hwnd, "marker.hlp", HELP_QUIT, NULL);
	   exit (0);
        }
      }
      if (wParam == 201 && janela == FALSE) {
         janela = TRUE;

	 wnd2class.lpszClassName  =  "SECOND";
	 wnd2class.hInstance      =  hgeral;
	 wnd2class.lpfnWndProc    =  SecondWndProc;
	 wnd2class.hCursor        =  LoadCursor (hgeral, "hand");
	 wnd2class.hIcon          =  NULL;
	 wnd2class.lpszMenuName   =  NULL;
	 wnd2class.hbrBackground  =  COLOR_WINDOW + 1;
	 wnd2class.style          =  CS_HREDRAW | CS_VREDRAW;
	 wnd2class.cbClsExtra     =  0;
	 wnd2class.cbWndExtra     =  0;

	 RegisterClass (&wnd2class);
       hwnd2  =  CreateWindow ("SECOND",               /* Class name.    */
			      "Inserir",                   /* Title.         */
                              WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME,         /* Style bits.    */
			      150,                          /* x - default.   */
			      150,                          /* y - default.   */
			      300,                         /* cx - default.  */
			      150,                         /* cy - default.  */
			      hwnd,                        /* No parent.     */
			      NULL,                        /* Class menu.    */
			      hgeral,                   /* Creator.       */
			      NULL                         /* Params.        */
			     );

         ShowWindow (hwnd2, SW_SHOW);
	 }
	 if (wParam == 202) {
	   dlgprc = MakeProcInstance ((FARPROC) FileOpenHookProc, hgeral);
           hwndDlg = CreateDialog (hgeral, "DIALOG_1", hwnd, dlgprc);
	 }
	 if (wParam == 203) {
	   dlgprc = MakeProcInstance ((FARPROC) SegundaJanelaDialogo, hgeral);
           DialogBox (hgeral, "DIALOG_2", hwnd, dlgprc);
	 }
	 if (wParam == 901) {
	   WinHelp (hwnd, "marker.hlp", HELP_CONTENTS, 0l);
	   return 0L; 
	 }
	}

    case WM_LBUTTONDOWN: { 
      if (cpt < 32) {
	if (cpt == 2)
	pt[cpt] = MAKEPOINT (lParam);
	cpt++;
	InvalidateRect (hwnd, NULL, TRUE);

      }
      break;

    }
    case WM_PAINT: {

      PAINTSTRUCT ps;
      int i;
      static char msg1 [] = "Carlos Fernando Bella Cruz",
		  msg2 [] = "Primeiro programa utilizando Windows",
		  msg3 [] = "Criado em 6 de fevereiro de 93",
		  msg4 [] = "             FIM";

      BeginPaint (hwnd, &ps);
					   
      TextOut (ps.hdc, 5, 5,  msg1, lstrlen (msg1));
      TextOut (ps.hdc, 5, 25, msg2, lstrlen (msg2));
      TextOut (ps.hdc, 5, 45, msg3, lstrlen (msg3));
      TextOut (ps.hdc, 5, 65, msg4, lstrlen (msg4));
      TextOut (ps.hdc, 5, 65, szTeste, lstrlen (szTeste));

      for (i = 0; i < cpt; i++)
	MarkerDrawMarker (ps.hdc, pt [i].x, pt [i].y);


      EndPaint (hwnd, &ps);

      break;
    }

    default:

      return (DefWindowProc (hwnd, msg, wParam, lParam));
      break;

   }

  return 0L;

}

UINT CALLBACK SegundaJanelaDialogo (HWND hwnd, UINT msg, WPARAM wParam,
    LPARAM lParam)
{
  switch (msg) {
    case WM_CLOSE:
      EndDialog (hwnd, 0);
      break;
    case WM_PAINT:
      SetDlgItemText (hwnd, 601, (LPCSTR)"Texto Modif");
      break;
    case WM_INITDIALOG:
      return TRUE;
    case WM_COMMAND: {
      if (wParam == 601) {
        HWND hwndMyEdit;
	hwndMyEdit = GetDlgItem (hwnd, 601);
	SendMessage (hwndMyEdit, WM_GETTEXT, sizeof (szTeste),
	   (LPARAM) ((LPSTR) szTeste));

        break;
      }
      if (wParam == 600)
	EndDialog (hwnd, 0); 
      break;
    }
  }
  return FALSE;
}
UINT CALLBACK FileOpenHookProc (HWND hwnd, UINT msg, WPARAM wParam,
    LPARAM lParam)
{
  switch (msg) {
    case WM_CLOSE:
      DestroyWindow (hwnd);
      break;
    case WM_INITDIALOG:
      return TRUE;
    case WM_COMMAND: { 
      if (wParam == 500)
	DestroyWindow (hwnd);
      break;
    }
  }
  return FALSE;
}

long FAR PASCAL SecondWndProc (HWND   hwnd,
		               WORD   msg,
			       WORD   wParam,
			       LONG   lParam)
{

  static POINT pt [32];
  static int   cpt = 0;

  switch (msg) {

 
    case WM_DESTROY:

      janela = FALSE;
//      PostQuitMessage (0);
      break;
                
    case WM_LBUTTONDOWN: {
      LOGFONT lf;
      CHOOSEFONT cf;

      memset (&cf, 0, sizeof (CHOOSEFONT));
      cf.lStructSize = sizeof (CHOOSEFONT);
      cf.hwndOwner = hwnd;
      cf.lpLogFont = &lf;
      cf.Flags = CF_SCREENFONTS|CF_EFFECTS;
      cf.rgbColors = RGB (0, 255, 255);
      cf.nFontType = SCREEN_FONTTYPE;

      ChooseFont (&cf);
      break;
    }      
    default:

      return (DefWindowProc (hwnd, msg, wParam, lParam));
      break;

  }

  return 0L;

}                

#define MARKERSIZE 3
VOID NEAR PASCAL MarkerDrawMarker (HDC hdc, int x, int y)
{

  DWORD dwColor;
  int i;

  dwColor = GetPixel (hdc, x, y);
  dwColor = ~dwColor;
  SetPixel (hdc, x, y, dwColor);

  for (i = 1; i <= MARKERSIZE; i++) {

    dwColor = GetPixel (hdc, x + i, y);
    dwColor = ~dwColor;
    SetPixel (hdc, x + i, y, dwColor);

    dwColor = GetPixel (hdc, x - i, y);
    dwColor = ~dwColor;
    SetPixel (hdc, x - i, y, dwColor);

    dwColor = GetPixel (hdc, x, y + i);
    dwColor = ~dwColor;
    SetPixel (hdc, x, y + i, dwColor);
               
    dwColor = GetPixel (hdc, x, y - i);
    dwColor = ~dwColor;
    SetPixel (hdc, x, y - i, dwColor);

  }

}